loadAPI(6);
host.setShouldFailOnDeprecatedUse(true);

host.defineController("O", "C", "0.1", "327312be-d35a-47eb-a79d-c58292d19661", "O");

var displayNames = [["Chords"],["Piano1","Piano2","Piano3","Piano4","Celesta1","Celesta2","Celesta3","Celesta4","Harp1","Harp2","Guitar1","Guitar2","Bassguitar1","Bassguitar2"],
["Lead1","Lead2","Lead3","Synth1","Synth2","BassElectro1","BassElectro2","Pad1","Pad2"],
["Minilogue 1","Minilogue 2","Minilogue 3","Minilogue 4","Monologue 1","Monologue 2","Arturia Minibrute 1","Arturia Minibrute 2","Arturia Minibrute 3","DSI Prophet 12","DSI Prophet REV2","Synth 12","Synth 13","Synth 14","Synth 15","Synth 16"],
["Generic Drum Kit","Subhit1","Subhit2","Lowhit1","Lowhit2","Midhit1","Midhit2","Highhit1","Highhit2","FX1","FX2","FX1","FX2"],
["Voice Female 1","Voice Female 2","Voice Male 1","Voice Male 2","Voice Child 1","Voice Child 2","Choir Female Soprano","Choir Female Mezzo","Choir Female Alto","Choir Male Tenor","Choir Male Baritone","Choir Male Bass","Choir Children","Choir Girls","Choir Boys"],
["Piccolo Legato","Piccolo Long","Piccolo Staccato","Piccolo Tenuto","Piccolo Marcato","Piccolo Longharmonics","Flute Legato","Flute Long","Flute Staccato","Flute Tenuto","Flute Marcato","Flute Longharmonics","Alto Flute Legato","Alto Flute Long","Alto Flute Staccato","Alto Flute Tenuto"],
["Alto Flute Marcato","Alto Flute Longharmonics","Bass Flute Legato","Bass Flute Long","Bass Flute Staccato","Bass Flute Tenuto","Bass Flute Marcato","Oboe Legato","Oboe Long","Oboe Staccato","Oboe Tenuto","Oboe Marcato","Cor Anglais Legato","Cor Anglais Long","Cor Anglais Staccato","Cor Anglais Tenuto"],
["Cor Anglais Marcato","Clarinet Legato","Clarinet Long","Clarinet Staccato","Clarinet Tenuto","Clarinet Marcato","Bass Clarinet Legato","Bass Clarinet Long","Bass Clarinet Staccato","Bass Clarinet Tenuto","Bass Clarinet Marcato","Contrabass Clarinet Legato","Contrabass Clarinet Long","Contrabass Clarinet Staccato","Contrabass Clarinet Tenuto","Contrabass Clarinet Marcato"],
["Bassoon Legato","Bassoon Long","Bassoon Staccato","Bassoon Tenuto","Bassoon Marcato","Bassoon Longharmonics","Contrabassoon Legato","Contrabassoon Long","Contrabassoon Staccato","Contrabassoon Tenuto","Contrabassoon Marcato"],
["Trumpets Legato","Trumpets Long","Trumpets Staccato","Trumpets Tenuto","Trumpets Marcato","Horns Legato","Horns Long","Horns Staccato","Horns Tenuto","Horns Marcato","Horns Staccatissimo","Trombones Legato","Trombones Long","Trombones Staccato","Trombones Tenuto","Trombones Marcato"],
["Trombones Longharmonics","Bass Trombone Legato","Bass Trombone Long","Bass Trombone Staccato","Bass Trombone Tenuto","Bass Trombone Marcato","Contrabass Trombone Legato","Contrabass Trombone Long","Contrabass Trombone Staccato","Contrabass Trombone Tenuto","Contrabass Trombone Marcato","Cimbasso Legato","Cimbasso Long","Cimbasso Staccato","Cimbasso Tenuto","Cimbasso Marcato"],
["Tuba Legato","Tuba Long","Tuba Staccato","Tuba Tenuto","Tuba Marcato","Contrabass Tuba Legato","Contrabass Tuba Long","Contrabass Tuba Staccato","Contrabass Tuba Tenuto","Contrabass Tuba Marcato"],
["Violins I Legato","Violins I Long","Violins I Spiccato","Violins I Tenuto","Violins I Marcato","Violins I Pizzicato","Violins I Tremolo","Violins I Longharmonics","Violins I Collegno","Violins I Longflautando","Violins I Longrachm","Violins I Marcatoattack","Violins I Pizzbartok","Violins I Shortharmonics","Violins II Legato","Violins II Long"],
["Violins II Spiccato","Violins II Tenuto","Violins II Marcato","Violins II Pizzicato","Violins II Tremolo","Violins II Longharmonics","Violins II Collegno","Violins II Longflautando","Violins II Marcatoattack","Violins II Pizzbartok","Violins II Shortharmonics","Viola Legato","Viola Long","Viola Spiccato","Viola Tenuto","Viola Marcato"],
["Viola Pizzicato","Viola Tremolo","Viola Longharmonics","Viola Collegno","Viola Longflautando","Viola Marcatoattack","Viola Pizzbartok","Viola Shortharmonics","Celli Legato","Celli Long","Celli Spiccato","Celli Tenuto","Celli Marcato","Celli Pizzicato","Celli Tremolo","Celli Longharmonics"],
["Celli Collegno","Celli Longflautando","Celli Marcatoattack","Celli Pizzbartok","Celli Shortharmonics","Double Bass Collegno","Double Bass Legato","Double Bass Long","Double Bass Longflautando","Double Bass Longharmonics","Double Bass Marcato","Double Bass Marcatoattack","Double Bass Pizzbartok","Double Bass Pizzicato","Double Bass Shortharmonics","Double Bass Spiccato"],
["Double Bass Tenuto","Double Bass Tremolo","Vir. Solo Violin Legato","Vir. Solo Cello Legato","Timpani","Triangle","Cymbals","Bassdrum","Snaredrum","Tenordrum","Tambourine","Castanets","Gong","Tubular Bells","Glockenspiel","Xylophone"]];

var midiInputPortCount = displayNames.length;
host.defineMidiPorts(midiInputPortCount, 1);

var LOWEST_CC = 1;
var HIGHEST_CC = 119;

   var midiPortBaseName = "orb ";
   var midiInputPortNames = new Array();
   for (var i = 0; i < midiInputPortCount; i++)
   {
      midiInputPortNames[i] = midiPortBaseName + i;
   }
   host.addDeviceNameBasedDiscoveryPair(midiInputPortNames, ["orb out"]);
   
if (host.platformIsWindows())
{
   // TODO: Set the correct names of the ports for auto detection on Windows platform here
   // and uncomment this when port names are correct.
   // host.addDeviceNameBasedDiscoveryPair(["Input Port 0", "Input Port 1"], ["Output Port 0"]);
   // var midiPortBaseName = "orb ";
   // var midiInputPortNames = new Array();
   // for (var i = 0; i < midiInputPortCount; i++)
   // {
      // midiInputPortNames[i] = midiPortBaseName + i;
   // }
   // host.addDeviceNameBasedDiscoveryPair(midiInputPortNames, ["orb out"]);

}
else if (host.platformIsMac())
{
   // TODO: Set the correct names of the ports for auto detection on Mac OSX platform here
   // and uncomment this when port names are correct.
   // host.addDeviceNameBasedDiscoveryPair(["Input Port 0", "Input Port 1"], ["Output Port 0"]);
}
else if (host.platformIsLinux())
{
   // TODO: Set the correct names of the ports for auto detection on Linux platform here
   // and uncomment this when port names are correct.
   // host.addDeviceNameBasedDiscoveryPair(["Input Port 0", "Input Port 1"], ["Output Port 0"]);
}

var midiInputPorts = new Array();

function init() {
   for (var i = 0; i < midiInputPortCount; i++)
   {
      midiInputPorts[i] = host.getMidiInPort(i);
      midiInputPorts[i].setMidiCallback(onMidi);
      midiInputPorts[i].setSysexCallback(onSysex);
      //Possibly add allChannels here
      // allChannels0 = midiIn0.createNoteInput("Port 0 All Channels", "??????");
      // allChannels0.setShouldConsumeEvents(false);

      for (var j = 0; j < displayNames[i].length; j++)
      {
         midiInputPorts[i].createNoteInput(displayNames[i][j], "?" + j.toString(16) + "????");
         // midiInputPorts[i].createNoteInput("Port " + i + " Channel " + (j + 1), "?" + j.toString(16) + "????");
      }
   }


transport = host.createTransport();

   // Make CCs 1-119 freely mappable
   userControls = host.createUserControls(HIGHEST_CC - LOWEST_CC + 1);

   for(var i=LOWEST_CC; i<=HIGHEST_CC; i++) {
      userControls.getControl(i - LOWEST_CC).setLabel("CC" + i);
   }
}

function onMidi(status, data1, data2) {
   if (isChannelController(status)) {
      if (data1 >= LOWEST_CC && data1 <= HIGHEST_CC) {
         var index = data1 - LOWEST_CC;
         userControls.getControl(index).set(data2, 128);
      }
   }
}

function onSysex(data) {
   // MMC Transport Controls:
   switch (data) {
      case "f07f7f0605f7":
         transport.rewind();
         break;
      case "f07f7f0604f7":
         transport.fastForward();
         break;
      case "f07f7f0601f7":
         transport.stop();
         break;
      case "f07f7f0602f7":
         transport.play();
         break;
      case "f07f7f0606f7":
         transport.record();
         break;
   }
}

function exit()
{
}
